import { Maybe, TaskID } from "./Interface";
import { Task, Tasks } from "./Task";
export declare class List<T = any> {
    private list;
    private _length;
    constructor(list?: Tasks<T>);
    private indexBound;
    private throwRangeError;
    get size(): number;
    entries(): Tasks<T>;
    first(): Maybe<Task<T>>;
    last(): Maybe<Task<T>>;
    at(index: number): Maybe<Task<T>>;
    range(index: number, count?: number): Maybe<Tasks<T>>;
    concat(list: Tasks<T>, prepend?: boolean): Tasks<T>;
    add(item: Task<T>): number;
    addFirst(item: Task<T>): number;
    addAt(index: number, item: Task<T>): Maybe<number>;
    remove(): Maybe<Task<T>>;
    removeFirst(): Maybe<Task<T>>;
    removeAt(index: number): Maybe<Task<T>>;
    removeRange(index: number, count?: number): Maybe<Tasks<T>>;
    removeById(id: TaskID): Maybe<Task<T>>;
    clear(): Tasks<T>;
}
