function DefaultOptions(name) {
    return {
        name: name,
        concurrency: 3,
        onAdd: undefined,
        onStart: undefined,
        onRun: undefined,
        onDone: undefined,
        onEnd: undefined,
        onRemove: undefined
    };
}

function __classPrivateFieldGet(receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
}

function __classPrivateFieldSet(receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value), 
    value;
}

typeof SuppressedError === "function" ? SuppressedError : function(error, suppressed, message) {
    var e = new Error(message);
    return e.name = "SuppressedError", e.error = error, e.suppressed = suppressed, e;
};

var TaskStatus;

(function(TaskStatus) {
    TaskStatus["PENDING"] = "pending";
    TaskStatus["RUNNING"] = "running";
    TaskStatus["CANCELLED"] = "cancelled";
    TaskStatus["DONE"] = "done";
})(TaskStatus || (TaskStatus = {}));

var RemovalMethods;

(function(RemovalMethods) {
    RemovalMethods["ALL"] = "all";
    RemovalMethods["BY_INDEX"] = "by-index";
    RemovalMethods["RANGE"] = "range";
    RemovalMethods["FIRST"] = "first";
    RemovalMethods["LAST"] = "last";
})(RemovalMethods || (RemovalMethods = {}));

var AdditionMethods;

(function(AdditionMethods) {
    AdditionMethods["FIRST"] = "first";
    AdditionMethods["LAST"] = "last";
    AdditionMethods["AT_INDEX"] = "at-index";
    AdditionMethods["MULTIPLE_FIRST"] = "multiple-first";
    AdditionMethods["MULTIPLE_LAST"] = "multiple-range";
})(AdditionMethods || (AdditionMethods = {}));

var RunnerEvents;

(function(RunnerEvents) {
    RunnerEvents["START"] = "onStart";
    RunnerEvents["PAUSE"] = "onPause";
    RunnerEvents["DESTROY"] = "onDestroy";
    RunnerEvents["ADD"] = "onAdd";
    RunnerEvents["REMOVE"] = "onRemove";
    RunnerEvents["RUN"] = "onRun";
    RunnerEvents["DONE"] = "onDone";
    RunnerEvents["END"] = "onEnd";
})(RunnerEvents || (RunnerEvents = {}));

var _Task__task, _Task__id, _Task__status;

class Task {
    constructor(id, task) {
        _Task__task.set(this, void 0);
        _Task__id.set(this, void 0);
        _Task__status.set(this, TaskStatus.PENDING);
        __classPrivateFieldSet(this, _Task__task, task, "f");
        __classPrivateFieldSet(this, _Task__id, id, "f");
    }
    get id() {
        return __classPrivateFieldGet(this, _Task__id, "f");
    }
    get status() {
        return __classPrivateFieldGet(this, _Task__status, "f");
    }
    set status(status) {
        if (Object.values(TaskStatus).includes(status)) {
            __classPrivateFieldSet(this, _Task__status, status, "f");
        }
    }
    run(done) {
        __classPrivateFieldGet(this, _Task__task, "f").call(this, done, this.id);
    }
}

_Task__task = new WeakMap, _Task__id = new WeakMap, _Task__status = new WeakMap;

var Namespace = Object.freeze({
    __proto__: null,
    get AdditionMethods() {
        return AdditionMethods;
    },
    DefaultOptions: DefaultOptions,
    get RemovalMethods() {
        return RemovalMethods;
    },
    get RunnerEvents() {
        return RunnerEvents;
    },
    Task: Task,
    get TaskStatus() {
        return TaskStatus;
    }
});

function isFunction(item) {
    return typeof item === "function";
}

function isNumber(item) {
    return typeof item === "number" && !isNaN(item);
}

function isArray(item) {
    return item.constructor === Array;
}

class List {
    constructor(list = []) {
        this._length = 0;
        this.list = list;
        this._length = list.length;
    }
    indexBound(index) {
        return !index || index > -1 && index < this._length;
    }
    throwRangeError(index) {
        throw new RangeError(`Index out of bounds. Expected index to be within range [0..${this._length - 1}]. Found ${index} instead.`);
    }
    get size() {
        return this._length;
    }
    entries() {
        return [ ...this.list ];
    }
    first() {
        return this.list.at(0);
    }
    last() {
        return this.list.at(-1);
    }
    at(index) {
        if (this.indexBound(index)) {
            return this.list[index];
        }
        return this.throwRangeError(index);
    }
    range(index, count) {
        if (this.indexBound(index)) {
            const end = isNumber(count) ? count + 1 : undefined;
            return this.list.slice(index, end);
        }
        return this.throwRangeError(index);
    }
    concat(list, prepend) {
        if (prepend) {
            this.list = list.concat(this.list);
        } else {
            this.list = this.list.concat(list);
        }
        this._length = this.list.length;
        return this.entries();
    }
    add(item) {
        this._length++;
        return this.list.push(item);
    }
    addFirst(item) {
        this._length++;
        return this.list.unshift(item);
    }
    addAt(index, item) {
        if (this.indexBound(index)) {
            this._length++;
            this.list.splice(index, 0, item);
            return index;
        }
        return this.throwRangeError(index);
    }
    remove() {
        if (this._length > 0) {
            this._length--;
            return this.list.pop();
        }
        return void 0;
    }
    removeFirst() {
        if (this._length > 0) {
            this._length--;
            return this.list.shift();
        }
        return void 0;
    }
    removeAt(index) {
        if (this.indexBound(index)) {
            this._length--;
            return this.list.splice(index, 1)[0];
        }
        return this.throwRangeError(index);
    }
    removeRange(index, count) {
        if (this.indexBound(index)) {
            const removed = this.list.splice(index, count);
            this._length -= removed.length;
            return removed;
        }
        return this.throwRangeError(index);
    }
    removeById(id) {
        const index = this.list.findIndex((task => task.id === id));
        if (index > -1) {
            this._length--;
            return this.list.splice(index, 1).at(0);
        }
        return void 0;
    }
    clear() {
        const removedTasks = this.list.slice();
        this._length = 0;
        this.list = [];
        return removedTasks;
    }
}

var _TaskRunner_instances, _a, _TaskRunner_instances_1, _TaskRunner__busy, _TaskRunner__paused, _TaskRunner__destroyed, _TaskRunner__pending, _TaskRunner__completed, _TaskRunner__running, _TaskRunner__options, _TaskRunner__duration, _TaskRunner__concurrency, _TaskRunner__taskIds, _TaskRunner_concurrency_set, _TaskRunner_total_get, _TaskRunner_completed_get, _TaskRunner_pending_get, _TaskRunner_running_get, _TaskRunner_runHook, _TaskRunner_createTask, _TaskRunner_done, _TaskRunner_run, _TaskRunner_provideRemovedTasks;

class TaskRunner {
    constructor(options) {
        var _b, _c, _d;
        _TaskRunner_instances.add(this);
        _TaskRunner__busy.set(this, false);
        _TaskRunner__paused.set(this, false);
        _TaskRunner__destroyed.set(this, false);
        _TaskRunner__pending.set(this, new List);
        _TaskRunner__completed.set(this, new List);
        _TaskRunner__running.set(this, new List);
        _TaskRunner__options.set(this, void 0);
        _TaskRunner__duration.set(this, {
            start: 0,
            end: 0,
            total: 0
        });
        _TaskRunner__concurrency.set(this, 0);
        _TaskRunner__taskIds.set(this, 0);
        __classPrivateFieldSet(this, _TaskRunner__options, Object.assign(Object.assign({}, DefaultOptions(`Runner-${__classPrivateFieldSet(_b = _a, _a, (_d = __classPrivateFieldGet(_b, _a, "f", _TaskRunner_instances_1), 
        _c = _d++, _d), "f", _TaskRunner_instances_1), _c}`)), options), "f");
        __classPrivateFieldSet(this, _TaskRunner_instances, __classPrivateFieldGet(this, _TaskRunner__options, "f").concurrency, "a", _TaskRunner_concurrency_set);
        Object.values(RunnerEvents).forEach((value => {
            this[value] = __classPrivateFieldGet(this, _TaskRunner__options, "f")[value];
        }));
    }
    get concurrency() {
        return __classPrivateFieldGet(this, _TaskRunner__concurrency, "f");
    }
    get busy() {
        return __classPrivateFieldGet(this, _TaskRunner__busy, "f");
    }
    get paused() {
        return __classPrivateFieldGet(this, _TaskRunner__paused, "f");
    }
    get destroyed() {
        return __classPrivateFieldGet(this, _TaskRunner__destroyed, "f");
    }
    get count() {
        return {
            total: __classPrivateFieldGet(this, _TaskRunner_instances, "a", _TaskRunner_total_get),
            completed: __classPrivateFieldGet(this, _TaskRunner_instances, "a", _TaskRunner_completed_get),
            running: __classPrivateFieldGet(this, _TaskRunner_instances, "a", _TaskRunner_running_get),
            pending: __classPrivateFieldGet(this, _TaskRunner_instances, "a", _TaskRunner_pending_get)
        };
    }
    get duration() {
        return Object.assign({}, __classPrivateFieldGet(this, _TaskRunner__duration, "f"));
    }
    get tasks() {
        const completed = __classPrivateFieldGet(this, _TaskRunner__completed, "f").entries();
        const pending = __classPrivateFieldGet(this, _TaskRunner__pending, "f").entries();
        const running = __classPrivateFieldGet(this, _TaskRunner__running, "f").entries();
        return {
            completed: completed,
            pending: pending,
            running: running,
            all: [ ...running, ...pending, ...completed ]
        };
    }
    start() {
        if (__classPrivateFieldGet(this, _TaskRunner__destroyed, "f")) {
            return false;
        }
        const previousPause = __classPrivateFieldGet(this, _TaskRunner__paused, "f");
        if (previousPause) {
            __classPrivateFieldSet(this, _TaskRunner__paused, false, "f");
        }
        if (__classPrivateFieldGet(this, _TaskRunner__busy, "f")) {
            return false;
        }
        __classPrivateFieldGet(this, _TaskRunner__duration, "f").start = Date.now();
        if (!previousPause) {
            __classPrivateFieldGet(this, _TaskRunner_instances, "m", _TaskRunner_runHook).call(this, RunnerEvents.START);
        }
        __classPrivateFieldGet(this, _TaskRunner_instances, "m", _TaskRunner_run).call(this);
        return true;
    }
    pause() {
        if (__classPrivateFieldGet(this, _TaskRunner__destroyed, "f")) {
            return false;
        }
        __classPrivateFieldSet(this, _TaskRunner__paused, true, "f");
        return true;
    }
    destroy() {
        __classPrivateFieldSet(this, _TaskRunner__destroyed, true, "f");
        __classPrivateFieldGet(this, _TaskRunner_instances, "m", _TaskRunner_runHook).call(this, RunnerEvents.DESTROY);
    }
    setConcurrency(concurrency) {
        if (!__classPrivateFieldGet(this, _TaskRunner__destroyed, "f")) {
            __classPrivateFieldSet(this, _TaskRunner_instances, concurrency, "a", _TaskRunner_concurrency_set);
            __classPrivateFieldGet(this, _TaskRunner_instances, "m", _TaskRunner_run).call(this);
        }
    }
    add(task, prepend) {
        if (!__classPrivateFieldGet(this, _TaskRunner__destroyed, "f")) {
            if (!isFunction(task) || task instanceof Task) {
                throw new TypeError("A task cannot be anything but a function, nor an instance of `Task`. Pass a function instead.");
            } else {
                if (prepend) {
                    __classPrivateFieldGet(this, _TaskRunner__pending, "f").addFirst(__classPrivateFieldGet(this, _TaskRunner_instances, "m", _TaskRunner_createTask).call(this, task));
                } else {
                    __classPrivateFieldGet(this, _TaskRunner__pending, "f").add(__classPrivateFieldGet(this, _TaskRunner_instances, "m", _TaskRunner_createTask).call(this, task));
                }
            }
            __classPrivateFieldGet(this, _TaskRunner_instances, "m", _TaskRunner_runHook).call(this, RunnerEvents.ADD, {
                method: prepend ? AdditionMethods.FIRST : AdditionMethods.LAST
            });
        }
    }
    addFirst(task) {
        this.add(task, true);
    }
    addAt(index, task) {
        if (!__classPrivateFieldGet(this, _TaskRunner__destroyed, "f")) {
            __classPrivateFieldGet(this, _TaskRunner__pending, "f").addAt(index, __classPrivateFieldGet(this, _TaskRunner_instances, "m", _TaskRunner_createTask).call(this, task));
            __classPrivateFieldGet(this, _TaskRunner_instances, "m", _TaskRunner_runHook).call(this, RunnerEvents.ADD, {
                method: AdditionMethods.AT_INDEX
            });
        }
    }
    addMultiple(tasks, prepend) {
        if (!__classPrivateFieldGet(this, _TaskRunner__destroyed, "f")) {
            __classPrivateFieldGet(this, _TaskRunner__pending, "f").concat(tasks.map(__classPrivateFieldGet(this, _TaskRunner_instances, "m", _TaskRunner_createTask).bind(this)), prepend);
            __classPrivateFieldGet(this, _TaskRunner_instances, "m", _TaskRunner_runHook).call(this, RunnerEvents.ADD, {
                method: prepend ? AdditionMethods.MULTIPLE_FIRST : AdditionMethods.MULTIPLE_LAST
            });
        }
    }
    addMultipleFirst(tasks) {
        this.addMultiple(tasks, true);
    }
    remove(first) {
        const removedTasks = first ? __classPrivateFieldGet(this, _TaskRunner__pending, "f").removeFirst() : __classPrivateFieldGet(this, _TaskRunner__pending, "f").remove();
        __classPrivateFieldGet(this, _TaskRunner_instances, "m", _TaskRunner_runHook).call(this, RunnerEvents.REMOVE, {
            removedTasks: __classPrivateFieldGet(this, _TaskRunner_instances, "m", _TaskRunner_provideRemovedTasks).call(this, removedTasks),
            method: first ? RemovalMethods.FIRST : RemovalMethods.LAST
        });
    }
    removeFirst() {
        this.remove(true);
    }
    removeAt(index) {
        const removedTasks = __classPrivateFieldGet(this, _TaskRunner__pending, "f").removeAt(index);
        __classPrivateFieldGet(this, _TaskRunner_instances, "m", _TaskRunner_runHook).call(this, RunnerEvents.REMOVE, {
            removedTasks: __classPrivateFieldGet(this, _TaskRunner_instances, "m", _TaskRunner_provideRemovedTasks).call(this, removedTasks),
            method: RemovalMethods.BY_INDEX
        });
    }
    removeRange(start, count) {
        const removedTasks = __classPrivateFieldGet(this, _TaskRunner__pending, "f").removeRange(start, count);
        __classPrivateFieldGet(this, _TaskRunner_instances, "m", _TaskRunner_runHook).call(this, RunnerEvents.REMOVE, {
            removedTasks: __classPrivateFieldGet(this, _TaskRunner_instances, "m", _TaskRunner_provideRemovedTasks).call(this, removedTasks),
            method: RemovalMethods.RANGE
        });
    }
    removeAll() {
        const removedTasks = __classPrivateFieldGet(this, _TaskRunner__pending, "f").clear();
        __classPrivateFieldGet(this, _TaskRunner_instances, "m", _TaskRunner_runHook).call(this, RunnerEvents.REMOVE, {
            removedTasks: __classPrivateFieldGet(this, _TaskRunner_instances, "m", _TaskRunner_provideRemovedTasks).call(this, removedTasks),
            method: RemovalMethods.ALL
        });
    }
    addListener(event, listener) {
        if (!__classPrivateFieldGet(this, _TaskRunner__destroyed, "f")) {
            if (!isFunction(listener)) {
                throw new TypeError(`Invalid listener callback provided. Expected ${event} to be a function, but found ${typeof listener} instead.`);
            }
            Object.assign(this, {
                [event]: listener
            });
        }
    }
    removeListener(event) {
        Object.assign(this, {
            [event]: undefined
        });
    }
}

_a = TaskRunner, _TaskRunner__busy = new WeakMap, _TaskRunner__paused = new WeakMap, 
_TaskRunner__destroyed = new WeakMap, _TaskRunner__pending = new WeakMap, _TaskRunner__completed = new WeakMap, 
_TaskRunner__running = new WeakMap, _TaskRunner__options = new WeakMap, _TaskRunner__duration = new WeakMap, 
_TaskRunner__concurrency = new WeakMap, _TaskRunner__taskIds = new WeakMap, _TaskRunner_instances = new WeakSet, 
_TaskRunner_concurrency_set = function _TaskRunner_concurrency_set(concurrency) {
    if (!concurrency || concurrency < -1) {
        throw new RangeError(`Invalid range for concurrency. Range should be a positive integer, or -1. Found ${concurrency} instead`);
    }
    if (concurrency === -1) {
        __classPrivateFieldSet(this, _TaskRunner__concurrency, Infinity, "f");
    } else {
        __classPrivateFieldSet(this, _TaskRunner__concurrency, concurrency, "f");
    }
}, _TaskRunner_total_get = function _TaskRunner_total_get() {
    return __classPrivateFieldGet(this, _TaskRunner_instances, "a", _TaskRunner_pending_get) + __classPrivateFieldGet(this, _TaskRunner_instances, "a", _TaskRunner_running_get) + __classPrivateFieldGet(this, _TaskRunner_instances, "a", _TaskRunner_completed_get);
}, _TaskRunner_completed_get = function _TaskRunner_completed_get() {
    return __classPrivateFieldGet(this, _TaskRunner__completed, "f").size;
}, _TaskRunner_pending_get = function _TaskRunner_pending_get() {
    return __classPrivateFieldGet(this, _TaskRunner__pending, "f").size;
}, _TaskRunner_running_get = function _TaskRunner_running_get() {
    return __classPrivateFieldGet(this, _TaskRunner__running, "f").size;
}, _TaskRunner_runHook = function _TaskRunner_runHook(...[hook, data]) {
    var _b, _c;
    (_c = (_b = this)[hook]) === null || _c === void 0 ? void 0 : _c.call(_b, Object.assign(Object.assign({}, data || {}), {
        tasks: this.tasks,
        count: this.count,
        duration: this.duration
    }));
}, _TaskRunner_createTask = function _TaskRunner_createTask(task) {
    var _b, _c;
    return new Task((__classPrivateFieldSet(this, _TaskRunner__taskIds, (_c = __classPrivateFieldGet(this, _TaskRunner__taskIds, "f"), 
    _b = _c++, _c), "f"), _b), task);
}, _TaskRunner_done = function _TaskRunner_done(task) {
    return result => {
        task.status = TaskStatus.DONE;
        __classPrivateFieldGet(this, _TaskRunner__running, "f").removeById(task.id);
        __classPrivateFieldGet(this, _TaskRunner__completed, "f").add(task);
        __classPrivateFieldGet(this, _TaskRunner_instances, "m", _TaskRunner_runHook).call(this, RunnerEvents.DONE, {
            task: task,
            result: result
        });
        if (!__classPrivateFieldGet(this, _TaskRunner__paused, "f") && !__classPrivateFieldGet(this, _TaskRunner__destroyed, "f")) {
            return __classPrivateFieldGet(this, _TaskRunner_instances, "m", _TaskRunner_run).call(this);
        }
        if (!__classPrivateFieldGet(this, _TaskRunner_instances, "a", _TaskRunner_running_get)) {
            if (__classPrivateFieldGet(this, _TaskRunner__paused, "f")) {
                return __classPrivateFieldGet(this, _TaskRunner_instances, "m", _TaskRunner_runHook).call(this, RunnerEvents.PAUSE);
            }
            if (__classPrivateFieldGet(this, _TaskRunner__destroyed, "f")) {
                return __classPrivateFieldGet(this, _TaskRunner_instances, "m", _TaskRunner_runHook).call(this, RunnerEvents.DESTROY);
            }
        }
    };
}, _TaskRunner_run = function _TaskRunner_run() {
    if (__classPrivateFieldGet(this, _TaskRunner_instances, "a", _TaskRunner_completed_get) !== __classPrivateFieldGet(this, _TaskRunner_instances, "a", _TaskRunner_total_get)) {
        if (!__classPrivateFieldGet(this, _TaskRunner__paused, "f") && __classPrivateFieldGet(this, _TaskRunner_instances, "a", _TaskRunner_running_get) < __classPrivateFieldGet(this, _TaskRunner__concurrency, "f")) {
            const difference = __classPrivateFieldGet(this, _TaskRunner__concurrency, "f") - __classPrivateFieldGet(this, _TaskRunner_instances, "a", _TaskRunner_running_get);
            const tasks = __classPrivateFieldGet(this, _TaskRunner__pending, "f").removeRange(0, difference);
            tasks.forEach((task => {
                task.status = TaskStatus.RUNNING;
                __classPrivateFieldGet(this, _TaskRunner__running, "f").add(task);
                task.run(__classPrivateFieldGet(this, _TaskRunner_instances, "m", _TaskRunner_done).call(this, task));
                __classPrivateFieldGet(this, _TaskRunner_instances, "m", _TaskRunner_runHook).call(this, RunnerEvents.RUN, {
                    task: task
                });
            }));
            __classPrivateFieldSet(this, _TaskRunner__busy, true, "f");
        }
    } else {
        __classPrivateFieldGet(this, _TaskRunner__duration, "f").end = Date.now();
        __classPrivateFieldGet(this, _TaskRunner__duration, "f").total = Math.ceil(__classPrivateFieldGet(this, _TaskRunner__duration, "f").end - __classPrivateFieldGet(this, _TaskRunner__duration, "f").start);
        __classPrivateFieldGet(this, _TaskRunner_instances, "m", _TaskRunner_runHook).call(this, RunnerEvents.END);
        __classPrivateFieldSet(this, _TaskRunner__busy, false, "f");
    }
}, _TaskRunner_provideRemovedTasks = function _TaskRunner_provideRemovedTasks(removedTasks) {
    if (isArray(removedTasks)) {
        return removedTasks;
    }
    if (removedTasks) {
        return [ removedTasks ];
    }
    return [];
};

_TaskRunner_instances_1 = {
    value: 0
};

export { Namespace as CT, TaskRunner };
